// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

/*
 * NOTE: This class is auto generated by the swagger code generator program (3.0.27).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package de.itzbund.egesetz.bmi.lea.api;

import de.itzbund.egesetz.bmi.lea.domain.dtos.document.DocumentDTO;
import de.itzbund.egesetz.bmi.lea.domain.dtos.homepage.DokumentenmappeTableDTOs;
import de.itzbund.egesetz.bmi.lea.domain.dtos.homepage.HomepageRegulatoryProposalDTO;
import de.itzbund.egesetz.bmi.lea.domain.dtos.homepage.RegelungsvorhabengTableDTOs;
import de.itzbund.egesetz.bmi.lea.domain.dtos.paging.PaginierungDTO;
import de.itzbund.egesetz.bmi.lea.domain.dtos.proposition.PropositionDTO;
import de.itzbund.egesetz.bmi.lea.domain.dtos.synopsis.SynopsisRequestDTO;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import javax.validation.Valid;
import java.util.List;
import java.util.Optional;
import java.util.UUID;

import static de.itzbund.egesetz.bmi.lea.api.ApiConstants.API_DIV_PROPOSITIONS;

@Validated
public interface PropositionsApi {

	/**
	 * @return ResponseEntity<List < PropositionDTO>>
	 */
	@Operation(
		summary = "Listet alle Regelungsvorhaben auf, auf die der Benutzer zugreifen kann.",
		description = "Menüpunkt: <b>Neue Dokumenten anlegen</b>",
		tags = {API_DIV_PROPOSITIONS},
		responses = {
			@ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json",
				schema = @Schema(implementation = PropositionDTO.class))),
			@ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
			@ApiResponse(responseCode = "403", description = "User has invalid rights", content = @Content())
		})
	@GetMapping(value = "/propositions",
		produces = {"application/json"}
	)
	ResponseEntity<List<PropositionDTO>> getAllPropositions();

	/**
	 * @return ResponseEntity<List < HomepageRegulatoryProposalDTO>>
	 * @deprecated
	 */
	@Deprecated(since = "5.12.0")
	@Operation(
		summary = "returns all regulatory proposals of the current user including metadata of compound and single documents",
		tags = {API_DIV_PROPOSITIONS},
		responses = {
			@ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json",
				schema = @Schema(implementation = HomepageRegulatoryProposalDTO.class))),
			@ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
			@ApiResponse(responseCode = "500", description = "An intrnal server error has occurred", content =
			@Content())
		})
	@GetMapping(value = "/regulatoryProposals", produces = {"application/json"})
	ResponseEntity<List<HomepageRegulatoryProposalDTO>> getAllRegulatoryProposals();

	@Operation(
		summary = "Listet alle Regelungsvorhaben, Dokumentenmappen und Dokumente für den <i>ersten Tab</i> auf; der Benutzer Ersteller ist.",
		description = "Menüpunkt: <b>Meine Dokumente</b>.<br>" +
			"<b>Die Funktionalität der Sortierung steht nicht zur Verfügung.</b>",
		tags = {API_DIV_PROPOSITIONS},
		responses = {
			@ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json",
				schema = @Schema(implementation = HomepageRegulatoryProposalDTO.class))),
			@ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
			@ApiResponse(responseCode = "500", description = "An intrnal server error has occurred", content =
			@Content())
		})
	@Parameter(in = ParameterIn.HEADER, name = "X-DE-BUND-EGG-Surrogate-For", schema = @Schema(type = "gid"))
	@PostMapping(value = "/meineDokumente", produces = {"application/json"})
	ResponseEntity<RegelungsvorhabengTableDTOs> getMeineDokumente(
		@Parameter(name = "PaginierungDTO", description = "Paging fuer Versionen", required = false)
		@RequestBody(required = false) Optional<PaginierungDTO> paginierungDTO
	);

	@Operation(
		summary = "Listet alle Regelungsvorhaben, Dokumentenmappen und Dokumente für den <i>zweiten Tab</i> auf; an denen der Benutzer mitwirkt.",
		description = "Menüpunkt: <b>Freigegebene Dokumente</b>.",
		tags = {API_DIV_PROPOSITIONS},
		responses = {
			@ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json",
				schema = @Schema(implementation = HomepageRegulatoryProposalDTO.class))),
			@ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
			@ApiResponse(responseCode = "500", description = "An intrnal server error has occurred", content =
			@Content())
		})
	@GetMapping(value = "/dokumenteAusAbstimmungen", produces = {"application/json"})
	ResponseEntity<List<HomepageRegulatoryProposalDTO>> getDokumenteAusAbstimmungen();


	/**
	 * POST /regulatoryProposal/{id} : Returns the given regulatory proposal, together with its compound documents, sorted by last updated.
	 *
	 * @param regulatoryProposalId UUID of the regulatory proposal (required)
	 * @param paginierungDTO
	 * @return OK (status code 200) or Access token is missing or invalid (status code 401) or User has invalid rights
	 * <p>
	 * <p>
	 * (status code 403) or Not Found &lt;/br&gt; Compound Document not found or **regulatoryProposalId** invalid.
	 * <p>
	 * <p>
	 * (status
	 * <p>
	 * <p>
	 * code 404) or Internal server error (status code 500)
	 */
	@Operation(
		summary = "Listet alle Dokumentenmappen und Dokumente in ihren Version auf.",
		description = "Menüpunkt: <b>Versionshistorie</b>.",
		tags = {API_DIV_PROPOSITIONS},
		responses = {
			@ApiResponse(responseCode = "200", description = "OK",
				content = @Content(mediaType = "application/json",
					schema = @Schema(implementation = HomepageRegulatoryProposalDTO.class))),
			@ApiResponse(responseCode = "401", description = "Access token is missing or invalid",
				content = @Content()),
			@ApiResponse(responseCode = "404", description = "Regelungsvorhaben not found or invalid id",
				content = @Content()),
			@ApiResponse(responseCode = "500", description = "An intrnal server error has occurred", content = @Content())
		})
	@PostMapping(value = "/regulatoryProposal/{id}", produces = {"application/json"})
	ResponseEntity<DokumentenmappeTableDTOs> getByRegulatoryProposalId(
		@Parameter(in = ParameterIn.PATH, description = "UUID of the regulatory proposal", required = true, schema = @Schema())
		@PathVariable("id") UUID regulatoryProposalId,
		@RequestBody(required = false) Optional<PaginierungDTO> paginierungDTO);


	@Operation(
		summary = "Erzeuge zu einem Bestandsrecht die Änderungsbefehle",
		description = "Menüpunkt: <b>Synopse</b> ⮞ <b>Versionshistorie</b>.",
		tags = {API_DIV_PROPOSITIONS},
		responses = {
			@ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json",
				schema = @Schema(implementation = DocumentDTO.class))),
			@ApiResponse(responseCode = "400", description = "Payload has errors", content = @Content()),
			@ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
			@ApiResponse(responseCode = "403", description = "User has invalid rights", content = @Content()),
			@ApiResponse(responseCode = "404", description = "Not Found </br> Document not found or **documentId** invalid.", content = @Content()),
			@ApiResponse(responseCode = "500", description = "An intrnal server error has occurred", content = @Content())
		})
	@PostMapping(
		value = "/regulatoryProposal/{id}/aenderungsbefehle",
		produces = {"application/json"})
	ResponseEntity<DocumentDTO> erzeugeAenderungsbefehle(
		@Parameter(in = ParameterIn.PATH, description = "UUID of the regulatory proposal", required = true, schema = @Schema())
		@PathVariable("id") UUID regulatoryProposalId,
		@Parameter(name = "SynopsisRequestDTO", required = true)
		@Valid @RequestBody
		SynopsisRequestDTO synopsisRequestDTO
	);

}
